/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**  swing_7
*/
#include <stdio.h>
#include <rms.h>
#include <ssdef.h>
#include <lnmdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

static load_node_names(ptr, so_far)
NODE *ptr;
char *so_far;
{
    char dir[SPEC_SIZE+1];

    sprintf(ptr->dir_name,"%s%s]",so_far,ptr->name);

    if (ptr->sister)
        load_node_names(ptr->sister, so_far);

    if (ptr->child)
    {
        sprintf(dir,"%s%s.",so_far,ptr->name);
        load_node_names(ptr->child,dir);
    }
}

load_up_node_names(d)
DSTRUCTURE *d;
{
    char device[SPEC_SIZE+1];

    sprintf(device,"%s[",d->device);
    load_node_names(d->fnp, device);
}

set_default(dir)
char *dir;
{
    int i, status, flag, length;

    char device[SPEC_SIZE+1];
    char directory[SPEC_SIZE+1];
    struct itmlst {
    short buffer_length;
    short item_code;
    long buffer_address;
    long return_length_address;
    long terminator;
    } item_list;

    /*
    **  set dir if specified
    */
    strcpy(directory,dir);

    if (strstr(directory,"[000000") && !strstr(directory,"[000000]"))
    {
        int i=0;
        while (directory[i++] != '[');
        strcpy(&directory[i],&directory[i+7]);
        while (directory[i++] != ']');
        directory[i] == 0;
    }

    status = chdir(directory);
    if (status)
    {
        structure_inconsistent(directory);
        return(FALSE);
    }

    /*
    **  we'll say SS$_NORMAL instead of RMS$_NORMAL
    */
    status = SS$_NORMAL;

    /*
    **  set SYS$DISK up to be the current device
    **  we must if we want to swing to another device
    */
    strcpy(device,dir);

    /*
    **  trim away the directories - leave the disk
    */
    flag = 0;
    for (i = 0 ; i < strlen(device) ; i++)
    {
        if (device[i] == '[')
        {
            /*
            **  beginning of directory
            */
            device[i] = 0;

            /*
            **  don't update unless we have to - save cpu
            */
            if (sys_disk[0] && strcmp(sys_disk,device) == 0)
                goto way_out;

            /*
            **  now set SYS$DISK to device, our device
            */
            if (strlen(device))
            {
                strcpy(sys_disk,device);
                status = lib$set_logical(DSC1("SYS$DISK"),
                                         DSC2(device));
                if (status != SS$_NORMAL && status != SS$_SUPERSEDE)
                    panic(status,"sys$crelnm","set def");
            }
            break;
        }
    }
way_out:;
    return(SS$_NORMAL);
}

show_deleting(nptr,rendition,sisters)
NODE *nptr;
int rendition;
int sisters;
{
    /*
    **  make display better by using batch pasteboard update
    */
    smg$begin_pasteboard_update(&paste);
    show_deleting_1(nptr,rendition,sisters);
    smg$end_pasteboard_update(&paste);
}

show_deleting_1(nptr,rendition,sisters)
NODE *nptr;
int rendition;
int sisters;
{
    if (nptr)
    {
        show_deleting_1(nptr->child,rendition,1);
        render(nptr->line, nptr->level, rendition);
        if (sisters)
            show_deleting_1(nptr->sister,rendition,1);
    }
}
